define(
    [
        'jquery',
        'uiComponent',
        'ko',
        'Magento_Checkout/js/model/quote',
        'Magento_Customer/js/model/customer',
        'Magento_Checkout/js/model/url-builder',
        'mage/storage',
    ], function ($, uiComponent, ko, quote, customer, urlBuilder, storage) {
        'use strict';

        return function (paymentMethod) {
            quote.paymentMethod(paymentMethod);

            var paymentData = paymentMethod;
            if (paymentData) {
                var serviceUrl;
                if (customer.isLoggedIn()) {
                    serviceUrl = urlBuilder.createUrl('/carts/mine/selected-payment-method', {});
                } else {
                    serviceUrl = urlBuilder.createUrl('/guest-carts/:cartId/selected-payment-method', {
                        cartId: quote.getQuoteId()
                    });
                }

                var payload = {
                    cartId: quote.getQuoteId(),
                    method: paymentData
                };

                storage.put(
                    serviceUrl,
                    JSON.stringify(payload)
                );
            }

        }
    });